MyGUI 3.2.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files
- Examples

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions
MyGUI::ListBox Class Reference

`#include <MyGUI_ListBox.h>`

Inheritance diagram for MyGUI::ListBox:
[legend]

## Public Types
typedef RTTIBase | Base
typedef ListBox | RTTIBase
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual const std::string & | getTypeName () const
virtual bool | isType (const std::type_info &_type) const
template<typename Type >
bool | isType () const
| ListBox ()
void | setItemNameAt (size_t _index, const UString &_name)
| Replace an item name at a specified position. More...
const UString & | getItemNameAt (size_t _index)
| Get item name from specified position. More...
int | getOptimalHeight ()
| Return optimal height to fit all items in ListBox. More...
Item Methods.
Methods used to manipulate items.
size_t | getItemCount () const
| Get number of items. More...
void | insertItemAt (size_t _index, const UString &_name, Any _data=Any::Null)
| Insert an item into a array at a specified position. More...
void | addItem (const UString &_name, Any _data=Any::Null)
| Add an item to the end of a array. More...
void | removeItemAt (size_t _index)
| Remove item at a specified position. More...
void | removeAllItems ()
| Remove all items. More...
void | swapItemsAt (size_t _index1, size_t _index2)
| Swap items at a specified positions. More...
size_t | findItemIndexWith (const UString &_name)
| Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found. More...
Item Selection Methods
Methods used to manipulate item selection.
size_t | getIndexSelected () const
void | setIndexSelected (size_t _index)
void | clearIndexSelected ()
Item Data Methods
Methods used to manipulate item user data.
void | setItemDataAt (size_t _index, Any _data)
| Replace an item data at a specified position. More...
void | clearItemDataAt (size_t _index)
| Clear an item data at a specified position. More...
template<typename ValueType >
ValueType * | getItemDataAt (size_t _index, bool _throw=true)
| Get item data from specified position. More...
Item Visibility Methods
Methods used to determine and manipulate item visibility.
void | beginToItemAt (size_t _index)
| Move all elements so specified becomes visible. More...
void | beginToItemFirst ()
| Move all elements so first becomes visible. More...
void | beginToItemLast ()
| Move all elements so last becomes visible. More...
void | beginToItemSelected ()
| Move all elements so selected becomes visible. More...
bool | isItemVisibleAt (size_t _index, bool _fill=true)
bool | isItemSelectedVisible (bool _fill=true)
| Same as ListBox::isItemVisibleAt for selected item. More...
void | setScrollVisible (bool _visible)
| Set scroll visible when it needed. More...
void | setScrollPosition (size_t _position)
| Set scroll position. More...
Widget Methods
Methods used to manipulate the widget's settings.
virtual void | setPosition (const IntPoint &_value)
virtual void | setSize (const IntSize &_value)
virtual void | setCoord (const IntCoord &_value)
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | _checkAlign ()
void | _setItemFocus (size_t _position, bool _focus)
void | _sendEventChangeScroll (size_t _position)
virtual size_t | _getItemCount ()
virtual void | _addItem (const MyGUI::UString &_name)
virtual void | _removeItemAt (size_t _index)
virtual void | _setItemNameAt (size_t _index, const UString &_name)
virtual const UString & | _getItemNameAt (size_t _index)
virtual void | _resetContainer (bool _update)
Public Member Functions inherited from MyGUI::Widget
template<typename Type >
bool | isType () const
| Widget ()
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
Widget * | createWidgetT (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
template<typename T >
T * | createWidget (WidgetStyle _style, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_value)
void | setRealSize (const FloatSize &_value)
void | setRealCoord (const FloatCoord &_value)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget. More...
virtual void | setVisible (bool _value)
bool | getVisible () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _value)
float | getAlpha () const
void | setInheritsAlpha (bool _value)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount ()
Widget * | getChildAt (size_t _index)
Widget * | findWidget (const std::string &_name)
void | findWidgets (const std::string &_name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord ()
Widget * | getClientWidget ()
void | detachFromWidget (const std::string &_layer="")
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, const std::string &_layer="")
void | changeWidgetSkin (const std::string &_skinName)
void | setWidgetStyle (WidgetStyle _style, const std::string &_layer="")
WidgetStyle | getWidgetStyle () const
void | setProperty (const std::string &_key, const std::string &_value)
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, const std::string &_skinName, Widget *_parent, ICroppedRectangle *_croppedParent, const std::string &_name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer ()
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
bool | _setWidgetState (const std::string &_value)
Public Member Functions inherited from MyGUI::IObject
template<typename Type >
bool | isType () const
template<typename Type >
Type * | castType (bool _throw=true)
template<typename Type >
const Type * | castType (bool _throw=true) const
| IObject ()
virtual | ~IObject ()
Public Member Functions inherited from MyGUI::ICroppedRectangle
| ICroppedRectangle ()
virtual | ~ICroppedRectangle ()
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
| UserData ()
virtual | ~UserData ()
void | setUserString (const std::string &_key, const std::string &_value)
const std::string & | getUserString (const std::string &_key) const
const MapString & | getUserStrings () const
bool | clearUserString (const std::string &_key)
bool | isUserString (const std::string &_key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType >
ValueType * | getUserData (bool _throw=true)
void | _setInternalData (Any _data)
template<typename ValueType >
ValueType * | _getInternalData (bool _throw=true)
Public Member Functions inherited from MyGUI::WidgetInput
| WidgetInput ()
virtual | ~WidgetInput ()
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (const std::string &_value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
| SkinItem ()
ISubWidgetText * | getSubWidgetText ()
ISubWidgetRect * | getSubWidgetMain ()
void | _setTextureName (const std::string &_texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
| LayerItem ()
virtual | ~LayerItem ()
ILayer * | getLayer () const
virtual void | attachItemToNode (ILayer *_layer, ILayerNode *_node)
virtual void | detachFromLayer ()
virtual void | upLayerItem ()
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::IItemContainer
| IItemContainer ()
virtual | ~IItemContainer ()
virtual Widget * | _getItemAt (size_t _index)
virtual void | _setItemSelected (IItem *_item)
Public Member Functions inherited from MyGUI::MemberObsolete< ListBox >
size_t | getItemIndexSelected ()
void | setItemSelectedAt (size_t _index)
void | clearItemSelected ()
void | insertItem (size_t _index, const UString &_item)
void | setItem (size_t _index, const UString &_item)
const UString & | getItem (size_t _index)
void | deleteItem (size_t _index)
void | deleteAllItems ()
size_t | findItem (const UString &_item)
size_t | getItemSelect ()
void | resetItemSelect ()
void | setItemSelect (size_t _index)
void | beginToIndex (size_t _index)
void | beginToStart ()
void | beginToEnd ()
void | beginToSelect ()
bool | isItemVisible (size_t _index, bool _fill=true)
bool | isItemSelectVisible (bool _fill=true)

## Static Public Member Functions
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::Widget
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static const std::string & | getClassTypeName ()

## Data Fields
EventPair < EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT > | eventListSelectAccept
EventPair < EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT > | eventListChangePosition
EventPair < EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT > | eventListMouseItemActivate
EventPair < EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT > | eventListMouseItemFocus
EventPair < EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT > | eventListChangeScroll
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPair3to4 < EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions
virtual void | initialiseOverride ()
virtual void | shutdownOverride ()
void | onMouseWheel (int _rel)
void | onKeyButtonPressed (KeyCode _key, Char _char)
void | notifyScrollChangePosition (ScrollBar *_sender, size_t _rel)
void | notifyMousePressed (Widget *_sender, int _left, int _top, MouseButton _id)
void | notifyMouseDoubleClick (Widget *_sender)
void | notifyMouseWheel (Widget *_sender, int _rel)
void | notifyMouseSetFocus (Widget *_sender, Widget *_old)
void | notifyMouseLostFocus (Widget *_sender, Widget *_new)
void | updateScroll ()
void | updateLine (bool _reset=false)
void | _setScrollView (size_t _position)
void | _redrawItemRange (size_t _start=0)
void | _redrawItem (size_t _index)
void | _selectIndex (size_t _index, bool _select)
virtual size_t | _getItemIndex (Widget *_item)
virtual void | setPropertyOverride (const std::string &_key, const std::string &_value)
Protected Member Functions inherited from MyGUI::Widget
virtual | ~Widget ()
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer, const std::string &_name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point)
virtual void | baseUpdateEnable ()
virtual ILayerItem * | getLayerItemByPoint (int _left, int _top) const
virtual const IntCoord & | getLayerItemCoord () const
template<typename T >
void | assignWidget (T *&_widget, const std::string &_name)
VectorWidgetPtr | getSkinWidgetsByName (const std::string &_name)
void | destroySkinWidget (Widget *_widget)
virtual void | onWidgetCreated (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
virtual void | onKeyChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (const std::string &_state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_node, bool _deep)
void | detachFromLayerItemNode (bool _deep)

## Additional Inherited Members
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin
ICroppedRectangle * | mCroppedParent

## Detailed Description

Definition at line 37 of file MyGUI_ListBox.h.

## Member Typedef Documentation

typedef RTTIBase MyGUI::ListBox::Base

Definition at line 42 of file MyGUI_ListBox.h.

typedef ListBox MyGUI::ListBox::RTTIBase

Definition at line 42 of file MyGUI_ListBox.h.

## Constructor & Destructor Documentation

MyGUI::ListBox::ListBox | ( |  | ) |

Definition at line 33 of file MyGUI_ListBox.cpp.

## Member Function Documentation

void MyGUI::ListBox::_addItem | ( | const MyGUI::UString & | _name | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 1057 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_checkAlign | ( |  | ) |

Definition at line 911 of file MyGUI_ListBox.cpp.

size_t MyGUI::ListBox::_getItemCount | ( |  | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 1052 of file MyGUI_ListBox.cpp.

size_t MyGUI::ListBox::_getItemIndex | ( | Widget * | _item | ) |
| protected virtual

Reimplemented from MyGUI::Widget.

Definition at line 1017 of file MyGUI_ListBox.cpp.

const UString & MyGUI::ListBox::_getItemNameAt | ( | size_t | _index | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 1072 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_redrawItem | ( | size_t | _index | ) |
| protected

Definition at line 515 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_redrawItemRange | ( | size_t | _start = `0` | ) |
| protected

Definition at line 461 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_removeItemAt | ( | size_t | _index | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 1062 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_resetContainer | ( | bool | _update | ) |
| virtual

Reimplemented from MyGUI::Widget.

Definition at line 1027 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_selectIndex | ( | size_t | _index,
|  | bool | _select
| ) |  |
| protected

Definition at line 679 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_sendEventChangeScroll | ( | size_t | _position | ) |

Definition at line 875 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_setItemFocus | ( | size_t | _position,
|  | bool | _focus
| ) |  |

Definition at line 824 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_setItemNameAt | ( | size_t | _index,
|  | const UString & | _name
| ) |  |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 1067 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::_setScrollView | ( | size_t | _position | ) |
| protected

Definition at line 850 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::addItem | ( | const UString & | _name,
|  | Any | _data = `Any::Null`
| ) |  |

Add an item to the end of a array.

Definition at line 959 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::beginToItemAt | ( | size_t | _index | ) |

Move all elements so specified becomes visible.

Definition at line 701 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::beginToItemFirst | ( |  | ) |

Move all elements so first becomes visible.

Definition at line 979 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::beginToItemLast | ( |  | ) |

Move all elements so last becomes visible.

Definition at line 985 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::beginToItemSelected | ( |  | ) |

Move all elements so selected becomes visible.

Definition at line 991 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::clearIndexSelected | ( |  | ) |

Clear item selection

Definition at line 969 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::clearItemDataAt | ( | size_t | _index | ) |

Clear an item data at a specified position.

Definition at line 974 of file MyGUI_ListBox.cpp.

size_t MyGUI::ListBox::findItemIndexWith | ( | const UString & | _name | ) |

Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.

Definition at line 934 of file MyGUI_ListBox.cpp.

static const std::string& MyGUI::ListBox::getClassTypeName | ( |  | ) |
| inline static

Definition at line 42 of file MyGUI_ListBox.h.

size_t MyGUI::ListBox::getIndexSelected | ( |  | ) | const

Get index of selected item (ITEM_NONE if none selected)

Definition at line 964 of file MyGUI_ListBox.cpp.

size_t MyGUI::ListBox::getItemCount | ( |  | ) | const

Get number of items.

Definition at line 954 of file MyGUI_ListBox.cpp.

template<typename ValueType >

ValueType* MyGUI::ListBox::getItemDataAt | ( | size_t | _index,
|  | bool | _throw = `true`
| ) |  |
| inline

Get item data from specified position.

Definition at line 109 of file MyGUI_ListBox.h.

const UString & MyGUI::ListBox::getItemNameAt | ( | size_t | _index | ) |

Get item name from specified position.

Definition at line 798 of file MyGUI_ListBox.cpp.

int MyGUI::ListBox::getOptimalHeight | ( |  | ) |

Return optimal height to fit all items in ListBox.

Definition at line 944 of file MyGUI_ListBox.cpp.

virtual const std::string& MyGUI::ListBox::getTypeName | ( |  | ) | const
| inline virtual

Get type name as string

Reimplemented from MyGUI::Widget.

Definition at line 42 of file MyGUI_ListBox.h.

void MyGUI::ListBox::initialiseOverride | ( |  | ) |
| protected virtual

Reimplemented from MyGUI::Widget.

Definition at line 47 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::insertItemAt | ( | size_t | _index,
|  | const UString & | _name,
|  | Any | _data = `Any::Null`
| ) |  |

Insert an item into a array at a specified position.

Definition at line 534 of file MyGUI_ListBox.cpp.

bool MyGUI::ListBox::isItemSelectedVisible | ( | bool | _fill = `true` | ) |

Same as ListBox::isItemVisibleAt for selected item.

Definition at line 997 of file MyGUI_ListBox.cpp.

bool MyGUI::ListBox::isItemVisibleAt | ( | size_t | _index,
|  | bool | _fill = `true`
| ) |  |

Return true if item visible

Parameters

  _index | of item
  _fill | false: function return true when whole item is visible true: function return true when at least part of item is visible

Definition at line 724 of file MyGUI_ListBox.cpp.

template<typename Type >

bool MyGUI::ListBox::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 42 of file MyGUI_ListBox.h.

virtual bool MyGUI::ListBox::isType | ( | const std::type_info & | _type | ) | const
| inline virtual

Compare with selected type

Reimplemented from MyGUI::Widget.

Definition at line 42 of file MyGUI_ListBox.h.

void MyGUI::ListBox::notifyMouseDoubleClick | ( | Widget * | _sender | ) |
| protected

Definition at line 293 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::notifyMouseLostFocus | ( | Widget * | _sender,
|  | Widget * | _new
| ) |  |
| protected

Definition at line 815 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::notifyMousePressed | ( | Widget * | _sender,
|  | int | _left,
|  | int | _top,
|  | MouseButton | _id
| ) |  |
| protected

Definition at line 247 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::notifyMouseSetFocus | ( | Widget * | _sender,
|  | Widget * | _old
| ) |  |
| protected

Definition at line 804 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::notifyMouseWheel | ( | Widget * | _sender,
|  | int | _rel
| ) |  |
| protected

Definition at line 212 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::notifyScrollChangePosition | ( | ScrollBar * | _sender,
|  | size_t | _rel
| ) |  |
| protected

Definition at line 241 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::onKeyButtonPressed | ( | KeyCode | _key,
|  | Char | _char
| ) |  |
| protected virtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 99 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::onMouseWheel | ( | int | _rel | ) |
| protected virtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 92 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::removeAllItems | ( |  | ) |

Remove all items.

Definition at line 759 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::removeItemAt | ( | size_t | _index | ) |

Remove item at a specified position.

Definition at line 596 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setCoord | ( | const IntCoord & | _value | ) |
| virtual

Set widget position and size

Reimplemented from MyGUI::Widget.

Definition at line 312 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setCoord | ( | int | _left,
|  | int | _top,
|  | int | _width,
|  | int | _height
| ) |  |

See Widget::setCoord(const IntCoord& _coord)

Definition at line 1012 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setIndexSelected | ( | size_t | _index | ) |

Select specified _index

Definition at line 668 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setItemDataAt | ( | size_t | _index,
|  | Any | _data
| ) |  |

Replace an item data at a specified position.

Definition at line 791 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setItemNameAt | ( | size_t | _index,
|  | const UString & | _name
| ) |  |

Replace an item name at a specified position.

Definition at line 784 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setPosition | ( | const IntPoint & | _value | ) |
| virtual

Set widget position (position of left top corner)

Reimplemented from MyGUI::Widget.

Definition at line 299 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setPosition | ( | int | _left,
|  | int | _top
| ) |  |

See Widget::setPosition(const IntPoint& _pos)

Definition at line 1002 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setPropertyOverride | ( | const std::string & | _key,
|  | const std::string & | _value
| ) |  |
| protected virtual

Reimplemented from MyGUI::Widget.

Definition at line 1040 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setScrollPosition | ( | size_t | _position | ) |

Set scroll position.

Definition at line 838 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setScrollVisible | ( | bool | _visible | ) |

Set scroll visible when it needed.

Definition at line 830 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setSize | ( | const IntSize & | _value | ) |
| virtual

Set widget size

Reimplemented from MyGUI::Widget.

Definition at line 304 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::setSize | ( | int | _width,
|  | int | _height
| ) |  |

See Widget::setSize(const IntSize& _size)

Definition at line 1007 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::shutdownOverride | ( |  | ) |
| protected virtual

Reimplemented from MyGUI::Widget.

Definition at line 84 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::swapItemsAt | ( | size_t | _index1,
|  | size_t | _index2
| ) |  |

Swap items at a specified positions.

Definition at line 882 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::updateLine | ( | bool | _reset = `false` | ) |
| protected

Definition at line 349 of file MyGUI_ListBox.cpp.

void MyGUI::ListBox::updateScroll | ( |  | ) |
| protected

Definition at line 320 of file MyGUI_ListBox.cpp.

## Field Documentation

EventPair<EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT> MyGUI::ListBox::eventListChangePosition

Event : Selected item position changed.
signature : void method(MyGUI::ListBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | of new item

Definition at line 207 of file MyGUI_ListBox.h.

EventPair<EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT> MyGUI::ListBox::eventListChangeScroll

Event : Position of scroll changed.
signature : void method(MyGUI::ListBox* _sender, size_t _position)

Parameters

  _sender | widget that called this event
  _position | of scroll

Definition at line 231 of file MyGUI_ListBox.h.

EventPair<EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT> MyGUI::ListBox::eventListMouseItemActivate

Event : Item was selected by mouse.
signature : void method(MyGUI::ListBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | index of selected item

Definition at line 215 of file MyGUI_ListBox.h.

EventPair<EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT> MyGUI::ListBox::eventListMouseItemFocus

Event : Mouse is over item.
signature : void method(MyGUI::ListBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | of focused item

Definition at line 223 of file MyGUI_ListBox.h.

EventPair<EventHandle_WidgetSizeT, EventHandle_ListPtrSizeT> MyGUI::ListBox::eventListSelectAccept

Event : Enter pressed or double click.
signature : void method(MyGUI::ListBox* _sender, size_t _index)

Parameters

  _sender | widget that called this event
  _index | of selected item

Definition at line 199 of file MyGUI_ListBox.h.

The documentation for this class was generated from the following files:

- MyGUI_ListBox.h
- MyGUI_ListBox.cpp